/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of y2038.xs. Do not edit this file, edit y2038.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "lib/Time/y2038.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <math.h>

#include "time64.h"

#define myPUSHi(int)   PUSHs(sv_2mortal(newSViv(int)));
#define myPUSHn(num)   PUSHs(sv_2mortal(newSVnv(num)));
#define myPUSHs(str)   PUSHs(sv_2mortal(str));


static const char * const dayname[] =
    {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
static const char * const monname[] =
    {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
     "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};


int about_eq(double left, double right, double epsilon) {
    double diff;

    if( left == right ) {
        return 1;
    }

    diff = fabs(left - right);

    if( diff < epsilon ) {
        return 1;
    }
    else {
        return 0;
    }
}


#line 49 "lib/Time/y2038.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 101 "lib/Time/y2038.c"

XS(XS_Time__y2038_gmtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_Time__y2038_gmtime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 47 "lib/Time/y2038.xs"
        Time64_T when;
        struct TM *err;
        struct TM date;
#line 119 "lib/Time/y2038.c"
#line 51 "lib/Time/y2038.xs"
        if( GIMME_V == G_VOID ) {
            warn("Useless use of gmtime() in void context");
            XSRETURN_EMPTY;
        }

        if( items == 0 ) {
            time_t small_when;
            time(&small_when);
            when = (Time64_T)small_when;
        }
        else {
            double when_float = SvNV(ST(0));
            when = (Time64_T)when_float;

            /* Check for Time64_T overflow */
            if( !about_eq((double)when, when_float, 1024.0) ) {
                warn("gmtime(%.0f) can not be represented", when_float);
                XSRETURN_EMPTY;
            }
        }

        err = gmtime64_r(&when, &date);

        if( err == NULL )
        {
            warn("gmtime(%.0f) can not be represented", (double)when);
            XSRETURN_EMPTY;
        }

        if( GIMME_V == G_ARRAY ) {
            EXTEND(SP, 9);
            myPUSHi(date.tm_sec);
            myPUSHi(date.tm_min);
            myPUSHi(date.tm_hour);
            myPUSHi(date.tm_mday);
            myPUSHi(date.tm_mon);
            myPUSHn((double)date.tm_year);
            myPUSHi(date.tm_wday);
            myPUSHi(date.tm_yday);
            myPUSHi(date.tm_isdst);
        }
        else {
            SV *tsv;
            /* XXX newSVpvf()'s %lld type is broken, so cheat with a double */
            double year = (double)date.tm_year + 1900;

            EXTEND(SP, 1);
            EXTEND_MORTAL(1);

            tsv = newSVpvf("%s %s %2d %02d:%02d:%02d %.0f",
                           dayname[date.tm_wday],
                           monname[date.tm_mon],
                           date.tm_mday,
                           date.tm_hour,
                           date.tm_min,
                           date.tm_sec,
                           year);
            myPUSHs(tsv);
        }
#line 180 "lib/Time/y2038.c"
	PUTBACK;
	return;
    }
}


XS(XS_Time__y2038_localtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_Time__y2038_localtime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 116 "lib/Time/y2038.xs"
        Time64_T when;
        struct TM *err;
        struct TM date;
#line 203 "lib/Time/y2038.c"
#line 120 "lib/Time/y2038.xs"
        if( GIMME_V == G_VOID ) {
            warn("Useless use of localtime() in void context");
            XSRETURN_EMPTY;
        }

        if( items == 0 ) {
            time_t small_when;
            time(&small_when);
            when = (Time64_T)small_when;
        }
        else {
            double when_float = SvNV(ST(0));
            when = (Time64_T)when_float;

            /* Check for Time64_T overflow */
            if( !about_eq((double)when, when_float, 1024.0) ) {
                warn("localtime(%.0f) can not be represented", when_float);
                XSRETURN_EMPTY;
            }
        }

	tzset();
        err = localtime64_r(&when, &date);

        if( err == NULL )
        {
            warn("localtime(%.0f) can not be represented", (double)when);
            XSRETURN_EMPTY;
        }

        if( GIMME_V == G_ARRAY ) {
            EXTEND(SP, 9);
            myPUSHi(date.tm_sec);
            myPUSHi(date.tm_min);
            myPUSHi(date.tm_hour);
            myPUSHi(date.tm_mday);
            myPUSHi(date.tm_mon);
            myPUSHn((double)date.tm_year);
            myPUSHi(date.tm_wday);
            myPUSHi(date.tm_yday);
            myPUSHi(date.tm_isdst);
        }
        else {
            SV *tsv;
            /* XXX newSVpvf()'s %lld type is broken, so cheat with a double */
            double year = (double)date.tm_year + 1900;

            EXTEND(SP, 1);
            EXTEND_MORTAL(1);

            tsv = newSVpvf("%s %s %2d %02d:%02d:%02d %.0f",
                           dayname[date.tm_wday],
                           monname[date.tm_mon],
                           date.tm_mday,
                           date.tm_hour,
                           date.tm_min,
                           date.tm_sec,
                           year);
            myPUSHs(tsv);
        }
#line 265 "lib/Time/y2038.c"
	PUTBACK;
	return;
    }
}


XS(XS_Time__y2038_timegm); /* prototype to pass -Wmissing-prototypes */
XS(XS_Time__y2038_timegm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	double	RETVAL;
	dXSTARG;
#line 185 "lib/Time/y2038.xs"
         struct TM date;
         Time64_T when;
#line 287 "lib/Time/y2038.c"
#line 188 "lib/Time/y2038.xs"
         if( items < 6 )
             croak("Usage: timegm($sec, $min, $hour, $mday, $month, $year)");

         date.tm_sec  = SvIV(ST(0));
         date.tm_min  = SvIV(ST(1));
         date.tm_hour = SvIV(ST(2));
         date.tm_mday = SvIV(ST(3));
         date.tm_mon  = SvIV(ST(4));
         date.tm_year = (Year)SvNV(ST(5));

         when = timegm64(&date);

         RETVAL = (double)when;

#line 303 "lib/Time/y2038.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Time__y2038_timelocal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Time__y2038_timelocal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	double	RETVAL;
	dXSTARG;
#line 209 "lib/Time/y2038.xs"
         struct TM date;
         Time64_T when;
#line 325 "lib/Time/y2038.c"
#line 212 "lib/Time/y2038.xs"
         if( items < 6 )
             croak("Usage: timelocal($sec, $min, $hour, $mday, $month, $year)");

         date.tm_sec  = SvIV(ST(0));
         date.tm_min  = SvIV(ST(1));
         date.tm_hour = SvIV(ST(2));
         date.tm_mday = SvIV(ST(3));
         date.tm_mon  = SvIV(ST(4));
         date.tm_year = (Year)SvNV(ST(5));

         date.tm_isdst = items >= 9 ? SvIV(ST(8)) : -1;

         when = mktime64(&date);

         RETVAL = (double)when;

#line 343 "lib/Time/y2038.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Time__y2038); /* prototype to pass -Wmissing-prototypes */
XS(boot_Time__y2038)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("Time::y2038::gmtime", XS_Time__y2038_gmtime, file, ";$");
        (void)newXSproto_portable("Time::y2038::localtime", XS_Time__y2038_localtime, file, ";$");
        (void)newXSproto_portable("Time::y2038::timegm", XS_Time__y2038_timegm, file, ";@");
        (void)newXSproto_portable("Time::y2038::timelocal", XS_Time__y2038_timelocal, file, ";@");
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

